package org.simantics.scl.compiler.elaboration.chr.relations;

import org.simantics.scl.compiler.common.exceptions.InternalCompilerError;
import org.simantics.scl.compiler.elaboration.chr.CHRRelation;
import org.simantics.scl.compiler.internal.parsing.Symbol;
import org.simantics.scl.compiler.types.TPred;
import org.simantics.scl.compiler.types.TVar;
import org.simantics.scl.compiler.types.Type;

public class UnresolvedCHRRelation extends Symbol implements CHRRelation {
    public String name;

    public UnresolvedCHRRelation(long location, String name) {
        this.location = location;
        this.name = name;
    }

    @Override
    public Type[] getParameterTypes() {
        throw new InternalCompilerError("Encountered unresolved CHRRelation during type checking.");
    }

    @Override
    public TVar[] getTypeVariables() {
        throw new InternalCompilerError("Encountered unresolved CHRRelation during type checking.");
    }
    
    public TPred[] getTypeConstraints() {
        throw new InternalCompilerError("Encountered unresolved CHRRelation during type checking.");
    }
}
