package org.simantics.scl.compiler.elaboration.equation;

import org.simantics.scl.compiler.elaboration.contexts.ReplaceContext;
import org.simantics.scl.compiler.elaboration.contexts.TranslationContext;
import org.simantics.scl.compiler.elaboration.contexts.TypingContext;
import org.simantics.scl.compiler.elaboration.expressions.Variable;
import org.simantics.scl.compiler.elaboration.expressions.VariableProcedure;
import org.simantics.scl.compiler.internal.parsing.Symbol;
import org.simantics.scl.compiler.types.Type;

import gnu.trove.map.hash.TObjectIntHashMap;
import gnu.trove.set.hash.THashSet;
import gnu.trove.set.hash.TIntHashSet;

public abstract class Equation extends Symbol {
    public static final Equation[] EMPTY_ARRAY = new Equation[0];    

    public abstract void setLocationDeep(long loc);

    public abstract void forVariables(VariableProcedure procedure);
    public abstract void collectFreeVariables(THashSet<Variable> vars);
    public abstract void collectEffects(THashSet<Type> effects);
    public abstract void checkType(TypingContext context);
    public abstract void collectRefs(TObjectIntHashMap<Object> allRefs, TIntHashSet refs);
    public abstract void collectVars(TObjectIntHashMap<Variable> allVars, TIntHashSet vars);
    public abstract void resolve(TranslationContext context);
    public abstract void accept(EquationVisitor visitor);
    public abstract Equation replace(ReplaceContext context);

}
